searchNodes=[{"ref":"Raxx.Session.html","title":"Raxx.Session","type":"module","doc":"A session is extracted from a request using extract/2. An updated session is sent the the client using embed/3 or a response To expire a session use expire/2 on a response. Configuration All session functions take a configuration as a parameter. To check configuration only one it is best to configure a session, and it&#39;s store, at startup. When using the SignedCookie or EncryptedCookie store then sessions are compatible with sessions from plug applications. Options :store - session store module (required) :key - session cookie key (required) Cookie options Any option that can be passed as an option to SetCookie.serialize/3 can be set as a session option. :domain, :max_age, :path, :http_only, :secure, :extra Store options Additional options may be required dependant on the store module being used. For example SignedCookie requires secret_key_base and salt."},{"ref":"Raxx.Session.html#clear_flash/1","title":"Raxx.Session.clear_flash/1","type":"function","doc":"Extract and discard all flash messages in a users session."},{"ref":"Raxx.Session.html#config/1","title":"Raxx.Session.config/1","type":"function","doc":"Set up and check session configuration. See options for details."},{"ref":"Raxx.Session.html#embed/3","title":"Raxx.Session.embed/3","type":"function","doc":"Overwrite a users session to a new value. The whole session object must be passed to this function."},{"ref":"Raxx.Session.html#expire/2","title":"Raxx.Session.expire/2","type":"function","doc":"Instruct a client to end a session."},{"ref":"Raxx.Session.html#extract/2","title":"Raxx.Session.extract/2","type":"function","doc":"Extract a session from a request. Returns {:ok, nil} if session cookie is not set. When session cookie is set but cannot be decoded or is tampered with an error will be returned."},{"ref":"Raxx.Session.html#extract/3","title":"Raxx.Session.extract/3","type":"function","doc":""},{"ref":"Raxx.Session.html#get_csrf_token/1","title":"Raxx.Session.get_csrf_token/1","type":"function","doc":"See Raxx.Session.CSRFProtection.get_csrf_token/1."},{"ref":"Raxx.Session.html#pop_flash/1","title":"Raxx.Session.pop_flash/1","type":"function","doc":"Returns all the flash messages in a users session. This will be a map of %{key =&gt; message} set using put_flash/3. The returned session will have no flash messages. Remember this session must be embedded in the response otherwise flashes will be seen twice."},{"ref":"Raxx.Session.html#put_flash/3","title":"Raxx.Session.put_flash/3","type":"function","doc":"Add a message into a sessions flash. Any key can be used for the message, however :info and :error are common."},{"ref":"Raxx.Session.CSRFProtection.html","title":"Raxx.Session.CSRFProtection","type":"module","doc":""},{"ref":"Raxx.Session.CSRFProtection.html#get_csrf_token/1","title":"Raxx.Session.CSRFProtection.get_csrf_token/1","type":"function","doc":""},{"ref":"Raxx.Session.CSRFProtection.html#safe_request?/1","title":"Raxx.Session.CSRFProtection.safe_request?/1","type":"function","doc":""},{"ref":"Raxx.Session.CSRFProtection.html#verify/2","title":"Raxx.Session.CSRFProtection.verify/2","type":"function","doc":""},{"ref":"Raxx.Session.EncryptedCookie.html","title":"Raxx.Session.EncryptedCookie","type":"module","doc":"Store the session in an encrypted cookie. This module is not normally used directly. Instead see Raxx.Session and use this module as the :store option. Options :secret_key_base - used to generate the signing key :signing_salt - a salt used with secret_key_base to generate a signing_secret. :encryption_salt - a salt used with secret_key_base to generate a encryption_secret."},{"ref":"Raxx.Session.EncryptedCookie.html#config/1","title":"Raxx.Session.EncryptedCookie.config/1","type":"function","doc":""},{"ref":"Raxx.Session.EncryptedCookie.html#fetch/2","title":"Raxx.Session.EncryptedCookie.fetch/2","type":"function","doc":""},{"ref":"Raxx.Session.EncryptedCookie.html#put/2","title":"Raxx.Session.EncryptedCookie.put/2","type":"function","doc":""},{"ref":"Raxx.Session.SignedCookie.html","title":"Raxx.Session.SignedCookie","type":"module","doc":"Stores the session in a signed cookie. Note: the contents of the cookie can be viewed by the client, an encrypted cookie store must be used to hide data from client. See Raxx.Session.EncryptedCookie. This module is not normally used directly. Instead see Raxx.Session and use this module as the :store option. Options :secret_key_base - used to generate the signing key :salt - a salt used with secret_key_base to generate a key for signing/verifying a cookie. TODO support key generation options, currently sensible defaults are used."},{"ref":"Raxx.Session.SignedCookie.html#config/1","title":"Raxx.Session.SignedCookie.config/1","type":"function","doc":""},{"ref":"Raxx.Session.SignedCookie.html#fetch/2","title":"Raxx.Session.SignedCookie.fetch/2","type":"function","doc":""},{"ref":"Raxx.Session.SignedCookie.html#put/2","title":"Raxx.Session.SignedCookie.put/2","type":"function","doc":""},{"ref":"readme.html","title":"Raxx.Session","type":"extras","doc":"Raxx.Session Manage HTTP cookies and storage for persistent client sessions. Install from hex.pm Documentation available on hexdoc Discuss on slack Extract, Embed, Expire a session defmodule MyApp.Action do use Raxx.SimpleServer alias Raxx.Session def handle_request(request, state) do {:ok, session} = Session.extract(request, state.session_config) updated_session = # ... processing response(:ok) |&gt; Session.embed(updated_session, state.session_config) # ... something went wrong response(:forbidden) |&gt; Session.expire(state.session_config) end end Sessions are extract and embedded in their entirety from requests/responses. A session is just a map where any term can be saved, although large terms might not work with certain session stores. If a session is updated it MUST be embedded in the response, otherwise the client will send the same previous session. Flash Flash protection used the :_flash key in a session, it should not be manipulated directly A flash is information that should be shown to a user only once. Raxx.Session provides some simple helpers to working with flashes. defmodule MyApp.Action do use Raxx.SimpleServer alias Raxx.Session def handle_request(%{path: [&quot;set-flash&quot;]}, state) do session = %{} |&gt; Session.put_flash(:info, &quot;Welcome to flash!&quot;) |&gt; Session.put_flash(:error, &quot;Welcome to flash!&quot;) redirect(&quot;/show-flash&quot;) |&gt; Session.embed(session, state.session_config) end def handle_request(request = %{path: [&quot;show-flash&quot;]}, state) do {:ok, session} = Session.extract(request, state.session_config) {flashes, session} = Session.pop_flash(session) response(:ok) |&gt; render(flashes) |&gt; Session.embed(session, state.session_config) end end CSRF Protection CSRF protection used the :_csrf_token key in a session, it should not be manipulated directly Raxx.Session.extract/2 is protected against CSRF attacks. Sessions can be extracted from safe requests. These are GET, HEAD or OPTIONS requests and they should have no side effect. Requests with other methods must provide a csrf_token. By default this value is looked for in the x-csrf-token header. If the token is sent to the server in a different manner it can be explicitly passed by using Raxx.Session.extract/3. For example if it is passed in the body of a request {%{&quot;_csrf_token&quot; =&gt; token}} = URI.decode(request.body) {:ok, session} = Raxx.Session.fetch(request, token, config) A CSRF token should not be sent back to the server as a query parameter. Configuration session_config = Raxx.Session.config( key: &quot;my_session&quot;, store: Raxx.Session.SignedCookie, secret_key_base: String.duplicate(&quot;squirrel&quot;, 8), salt: &quot;epsom&quot; ) For all configuration options see Raxx.Session or specific stores. Plug sessions Sessions from Plug applications can be verified in Raxx applications, and visa versa, if setup with the same configuration."}]